
enum EXP_SORT {EXP_CONST, EXP_VAR, EXP_TPL, EXP_LET, EXP_ARRAY, EXP_GET};

struct exp_const{
	unsigned int val;
};

struct exp_var{
	char *vname;
};

struct exp_tpl{
	struct gexplist *comps;
};

struct exp_let{
	char *vname;
	struct glb_exp *gexp;
	struct glb_exp *next;
};

struct exp_array{
	unsigned int lenn;
	struct glb_exp *initvaln;
};

struct exp_get{
	char *aname;
	unsigned int index;
};


struct glb_exp{
	enum EXP_SORT sort;
	union {
		struct exp_const constb;
		struct exp_var varb;
		struct exp_tpl tplb;
		struct exp_let letb;
		struct exp_array arrayb;
		struct exp_get getb;
	} body;
};

struct gexplist{
	struct glb_exp *gexp;
	struct gexplist *next;
};


struct glblets{
	char *vname;
	struct glb_exp *gexp;
	struct glblets *next;
};


struct gexplist *new_gexplist(struct glb_exp *ge, struct gexplist *nget);
void delete_gexplist(struct gexplist *gel);

struct glb_exp *new_gexp(enum EXP_SORT gnsort);
void delete_gexp(struct glb_exp *ge);

struct glblets *new_glblets(char *vn, struct glb_exp *ge, struct glblets *nxt);
void delete_glblets(struct glblets *gl);

int compile(struct glblets *gl, char *outfilename);
